Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3274)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3272 2018-09-24 10:16:32Z suehring
 ! - split direct and diffusion shortwave radiation using RRTMG rather than using
 !   calc_diffusion_radiation, in case of RRTMG
@@ -103,5 +106,5 @@
 ! 
 ! 3117 2018-07-11 09:59:11Z maronga
-! Bugfix: water vapor was not transfered to RRTMG when cloud_physics = .F.
+! Bugfix: water vapor was not transfered to RRTMG when bulk_cloud_model = .F.
 ! Bugfix: changed the calculation of RRTMG boundary conditions (Mohamed Salim)
 ! Bugfix: dry residual atmosphere is replaced by standard RRTMG atmosphere
@@ -437,21 +440,19 @@
  
     USE arrays_3d,                                                             &
-        ONLY:  dzw, hyp, nc, pt, q, ql, zu, zw
+        ONLY:  dzw, hyp, nc, pt, q, ql, zu, zw, exner, d_exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, g, lv_d_cp, l_v, pi, r_d, rho_l, solar_constant,           &
+               barometric_formula
 
     USE calc_mean_profile_mod,                                                 &
         ONLY:  calc_mean_profile
 
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, l_d_cp, l_v, r_d, rho_l
-
-    USE constants,                                                             &
-        ONLY:  pi
-
     USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, cloud_physics, coupling_char, dz, g,            &
+        ONLY:  cloud_droplets, coupling_char, dz,                              &
                humidity,                                                       &
                initializing_actions, io_blocks, io_group,                      &
                latitude, longitude, large_scale_forcing, lsf_surf,             &
-               message_string, microphysics_morrison, plant_canopy, pt_surface,&
+               message_string, plant_canopy, pt_surface,&
                rho_surface, surface_pressure, time_since_reference_point,      &
                urban_surface, land_surface, end_time, spinup_time, dt_spinup
@@ -475,6 +476,6 @@
     USE kinds
 
-    USE microphysics_mod,                                                      &
-        ONLY:  na_init, nc_const, sigma_gc
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, microphysics_morrison, na_init, nc_const, sigma_gc
 
 #if defined ( __netcdf )
@@ -561,4 +562,6 @@
                                                          /)
 
+    REAL(wp), PARAMETER :: sigma_sb       = 5.67037321E-8_wp !< Stefan-Boltzmann constant
+
     INTEGER(iwp) :: albedo_type  = 9999999, & !< Albedo surface type
                     dots_rad     = 0          !< starting index for timeseries output 
@@ -578,8 +581,4 @@
                                                         !< will be considered. However fewer SVFs are expected.
                 radiation_interactions_on = .TRUE.      !< namelist flag to force RTM activiation regardless to vertical urban/land surface and trees
-
-
-    REAL(wp), PARAMETER :: sigma_sb       = 5.67037321E-8_wp,       & !< Stefan-Boltzmann constant
-                           solar_constant = 1368.0_wp                 !< solar constant at top of atmosphere
 
     REAL(wp) :: albedo = 9999999.9_wp,           & !< NAMELIST alpha
@@ -2274,6 +2273,6 @@
 !
 !--       Initialize RRTMG
-          IF ( lw_radiation )  CALL rrtmg_lw_ini ( cp )
-          IF ( sw_radiation )  CALL rrtmg_sw_ini ( cp )
+          IF ( lw_radiation )  CALL rrtmg_lw_ini ( c_p )
+          IF ( sw_radiation )  CALL rrtmg_sw_ini ( c_p )
 
 !
@@ -2335,7 +2334,4 @@
 
        INTEGER(iwp) ::  l         !< running index for surface orientation
-
-       REAL(wp)     ::  exn       !< Exner functions at surface
-       REAL(wp)     ::  exn1      !< Exner functions at first grid level or at urban layer top 
        REAL(wp)     ::  pt1       !< potential temperature at first grid level or mean value at urban layer top 
        REAL(wp)     ::  pt1_l     !< potential temperature at first grid level or mean value at urban layer top at local subdomain 
@@ -2355,5 +2351,4 @@
 !
 !--    Calculate value of the Exner function at model surface
-       exn = (surface_pressure / 1000.0_wp )**0.286_wp
 !
 !--    In case averaged radiation is used, calculate mean temperature and 
@@ -2361,21 +2356,20 @@
        IF ( average_radiation ) THEN   
           pt1   = 0.0_wp
-          IF ( cloud_physics  .OR.  cloud_droplets )  ql1   = 0.0_wp
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1   = 0.0_wp
 
           pt1_l = SUM( pt(nzut,nys:nyn,nxl:nxr) )
-          IF ( cloud_physics  .OR.  cloud_droplets  )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
+          IF ( bulk_cloud_model  .OR.  cloud_droplets  )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
 
 #if defined( __parallel )      
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( cloud_physics  .OR.  cloud_droplets )                            &
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )                            &
              CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
           pt1 = pt1_l 
-          IF ( cloud_physics  .OR.  cloud_droplets )  ql1 = ql1_l
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1 = ql1_l
 #endif
- 
-          exn1 = ( hyp(nzut) / 100000.0_wp )**0.286_wp
-          IF ( cloud_physics  .OR.  cloud_droplets  )  pt1 = pt1 + l_d_cp / exn1 * ql1
+
+          IF ( bulk_cloud_model  .OR.  cloud_droplets  )  pt1 = pt1 + lv_d_cp / exner(nzut) * ql1
 !
 !--       Finally, divide by number of grid points
@@ -2418,10 +2412,8 @@
                 k = nzut
 
-                exn1 = ( hyp(k+1) / 100000.0_wp )**0.286_wp
-
                 surf%rad_sw_in  = solar_constant * sky_trans * zenith(0)
                 surf%rad_sw_out = albedo_urb * surf%rad_sw_in
                 
-                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exner(k+1))**4
 
                 surf%rad_lw_out = emissivity_urb * sigma_sb * (t_rad_urb)**4   &
@@ -2443,6 +2435,4 @@
                    j = surf%j(m)
                    k = surf%k(m)
-
-                   exn1 = (hyp(k) / 100000.0_wp )**0.286_wp
 
                    surf%rad_sw_in(m) = solar_constant * sky_trans * zenith(0)
@@ -2469,5 +2459,5 @@
                                         )                                      &
                                         * sigma_sb                             &
-                                        * ( surf%pt_surface(m) * exn )**4
+                                        * ( surf%pt_surface(m) * exner(nzb) )**4
 
                    surf%rad_lw_out_change_0(m) =                               &
@@ -2479,12 +2469,12 @@
                                         surf%emissivity(ind_wat_win,m)         &
                                       ) * 3.0_wp * sigma_sb                    &
-                                      * ( surf%pt_surface(m) * exn )** 3
-
-
-                   IF ( cloud_physics  .OR.  cloud_droplets  )  THEN
-                      pt1 = pt(k,j,i) + l_d_cp / exn1 * ql(k,j,i)
-                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+                                      * ( surf%pt_surface(m) * exner(nzb) )** 3
+
+
+                   IF ( bulk_cloud_model  .OR.  cloud_droplets  )  THEN
+                      pt1 = pt(k,j,i) + lv_d_cp / exner(k) * ql(k,j,i)
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exner(k))**4
                    ELSE
-                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt(k,j,i) * exn1)**4
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt(k,j,i) * exner(k))**4
                    ENDIF
 
@@ -2524,6 +2514,4 @@
        INTEGER(iwp) ::  l         !< running index for surface orientation
 
-       REAL(wp)     ::  exn       !< Exner functions at surface
-       REAL(wp)     ::  exn1      !< Exner functions at first grid level
        REAL(wp)     ::  pt1       !< potential temperature at first grid level or mean value at urban layer top 
        REAL(wp)     ::  pt1_l     !< potential temperature at first grid level or mean value at urban layer top at local subdomain 
@@ -2531,9 +2519,6 @@
        REAL(wp)     ::  ql1_l     !< liquid water mixing ratio at first grid level or mean value at urban layer top at local subdomain 
 
-       TYPE(surf_type), POINTER ::  surf !< pointer on respective surface type, used to generalize routine   
-
-!
-!--    Calculate value of the Exner function
-       exn = (surface_pressure / 1000.0_wp )**0.286_wp
+       TYPE(surf_type), POINTER ::  surf !< pointer on respective surface type, used to generalize routine
+
 !
 !--    In case averaged radiation is used, calculate mean temperature and 
@@ -2541,19 +2526,19 @@
        IF ( average_radiation ) THEN   
           pt1   = 0.0_wp
-          IF ( cloud_physics  .OR.  cloud_droplets )  ql1   = 0.0_wp
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1   = 0.0_wp
 
           pt1_l = SUM( pt(nzut,nys:nyn,nxl:nxr) )
-          IF ( cloud_physics  .OR.  cloud_droplets )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1_l = SUM( ql(nzut,nys:nyn,nxl:nxr) )
 
 #if defined( __parallel )      
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           CALL MPI_ALLREDUCE( pt1_l, pt1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( cloud_physics  .OR.  cloud_droplets )                             &
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )                             &
              CALL MPI_ALLREDUCE( ql1_l, ql1, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
           pt1 = pt1_l
-          IF ( cloud_physics  .OR.  cloud_droplets )  ql1 = ql1_l
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  ql1 = ql1_l
 #endif
-          IF ( cloud_physics  .OR.  cloud_droplets )  pt1 = pt1 + l_d_cp / exn1 * ql1
+          IF ( bulk_cloud_model  .OR.  cloud_droplets )  pt1 = pt1 + lv_d_cp / exner(nzut+1) * ql1
 !
 !--       Finally, divide by number of grid points
@@ -2595,12 +2580,7 @@
              IF ( average_radiation ) THEN
 
-                ! set height above canopy
-                k = nzut
-
                 surf%rad_net = net_radiation
-! MS: Wyh k + 1 ?
-                exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
-
-                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+
+                surf%rad_lw_in  = 0.8_wp * sigma_sb * (pt1 * exner(nzut+1))**4
 
                 surf%rad_lw_out = emissivity_urb * sigma_sb * (t_rad_urb)**4   &
@@ -2636,12 +2616,10 @@
                    surf%rad_net(m) = net_radiation
 
-                   exn1 = (hyp(k) / 100000.0_wp )**0.286_wp
-
-                   IF ( cloud_physics  .OR.  cloud_droplets )  THEN
-                      pt1 = pt(k,j,i) + l_d_cp / exn1 * ql(k,j,i)
-                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+                   IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
+                      pt1 = pt(k,j,i) + lv_d_cp / exner(k) * ql(k,j,i)
+                      surf%rad_lw_in(m)  = 0.8_wp * sigma_sb * (pt1 * exner(k))**4
                    ELSE
                       surf%rad_lw_in(m)  = 0.8_wp * sigma_sb *                 &
-                                             ( pt(k,j,i) * exn1 )**4
+                                             ( pt(k,j,i) * exner(k) )**4
                    ENDIF
 
@@ -2656,5 +2634,5 @@
                                         )                                      &
                                       * sigma_sb                               &
-                                      * ( surf%pt_surface(m) * exn )**4
+                                      * ( surf%pt_surface(m) * exner(nzb) )**4
 
                    surf%rad_sw_in(m) = ( surf%rad_net(m) - surf%rad_lw_in(m)   &
@@ -2954,5 +2932,5 @@
           rrtm_tlev(0,nzb+1) = t_rad_urb
 
-          IF ( cloud_physics )  THEN
+          IF ( bulk_cloud_model )  THEN
 
              CALL calc_mean_profile( ql, 54 )
@@ -2962,5 +2940,5 @@
              DO k = nzb+1, nzt+1
                 rrtm_tlay(0,k) = pt_av(k) * ( (hyp(k) ) / 100000._wp       &
-                                 )**.286_wp + l_d_cp * ql_av(k)
+                                 )**.286_wp + lv_d_cp * ql_av(k)
                 rrtm_h2ovmr(0,k) = mol_mass_air_d_wv * (q_av(k) - ql_av(k))
              ENDDO
@@ -3013,5 +2991,5 @@
           rrtm_icld   = 0
 
-          IF ( cloud_physics )  THEN
+          IF ( bulk_cloud_model )  THEN
              DO k = nzb+1, nzt+1
                 rrtm_cliqwp(0,k) =  ql_av(k) * 1000._wp *                   &
@@ -3133,29 +3111,26 @@
 !--             Prepare profiles of temperature and H2O volume mixing ratio
                 DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                   rrtm_tlev(0,nzb+1) = surf_lsm_h%pt_surface(m) * &
-                                    ( surface_pressure / 1000.0_wp )**0.286_wp
+                   rrtm_tlev(0,nzb+1) = surf_lsm_h%pt_surface(m) * exner(nzb)
                 ENDDO
                 DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                   rrtm_tlev(0,nzb+1) = surf_usm_h%pt_surface(m) * &
-                                    ( surface_pressure / 1000.0_wp )**0.286_wp
+                   rrtm_tlev(0,nzb+1) = surf_usm_h%pt_surface(m) * exner(nzb)
                 ENDDO
 
 
-                IF ( cloud_physics )  THEN
+                IF ( bulk_cloud_model )  THEN
                    DO k = nzb+1, nzt+1
-                      rrtm_tlay(0,k) = pt(k,j,i) * ( (hyp(k) ) / 100000.0_wp   &
-                                       )**0.286_wp + l_d_cp * ql(k,j,i)
+                      rrtm_tlay(0,k) = pt(k,j,i) * exner(k)                    &
+                                        + lv_d_cp * ql(k,j,i)
                       rrtm_h2ovmr(0,k) = mol_mass_air_d_wv * (q(k,j,i) - ql(k,j,i))
                    ENDDO
                 ELSEIF ( cloud_droplets )  THEN
                    DO k = nzb+1, nzt+1
-                      rrtm_tlay(0,k) = pt(k,j,i) * ( (hyp(k) ) / 100000.0_wp   &
-                                       )**0.286_wp + l_d_cp * ql(k,j,i)
+                      rrtm_tlay(0,k) = pt(k,j,i) * exner(k)                     &
+                                        + lv_d_cp * ql(k,j,i)
                       rrtm_h2ovmr(0,k) = mol_mass_air_d_wv * q(k,j,i) 
                    ENDDO
                 ELSE
                    DO k = nzb+1, nzt+1
-                      rrtm_tlay(0,k) = pt(k,j,i) * ( (hyp(k) ) / 100000.0_wp   &
-                                       )**0.286_wp
+                      rrtm_tlay(0,k) = pt(k,j,i) * exner(k)
                    ENDDO
 
@@ -3202,5 +3177,5 @@
                 rrtm_icld   = 0
 
-                IF ( cloud_physics  .OR.  cloud_droplets )  THEN
+                IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
                    DO k = nzb+1, nzt+1
                       rrtm_cliqwp(0,k) =  ql(k,j,i) * 1000.0_wp *              &
@@ -3214,5 +3189,5 @@
 !
 !--                      Calculate cloud droplet effective radius
-                         IF ( cloud_physics )  THEN
+                         IF ( bulk_cloud_model )  THEN
 !
 !--                         Calculete effective droplet radius. In case of using 
@@ -3285,6 +3260,5 @@
                                surf_lsm_h%frac(ind_wat_win,m)   *              &
                                surf_lsm_h%emissivity(ind_wat_win,m)
-                   rrtm_tsfc = surf_lsm_h%pt_surface(m) *                      &
-                                       (surface_pressure / 1000.0_wp )**0.286_wp
+                   rrtm_tsfc = surf_lsm_h%pt_surface(m) * exner(nzb)
                 ENDDO             
                 DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
@@ -3295,6 +3269,5 @@
                                surf_usm_h%frac(ind_wat_win,m)   *              &
                                surf_usm_h%emissivity(ind_wat_win,m)
-                   rrtm_tsfc = surf_usm_h%pt_surface(m) *                      &
-                                       (surface_pressure / 1000.0_wp )**0.286_wp
+                   rrtm_tsfc = surf_usm_h%pt_surface(m) * exner(nzb)
                 ENDDO
 !
@@ -3985,9 +3958,10 @@
        ALLOCATE ( rrtm_plev(0:0,nzb+1:nzt_rad+2)   )
 
-       t_surface = pt_surface * ( surface_pressure / 1000.0_wp )**0.286_wp
+       t_surface = pt_surface * exner(nzb)
        DO k = nzb+1, nzt+1
           rrtm_play(0,k) = hyp(k) * 0.01_wp
-          rrtm_plev(0,k) = surface_pressure * ( (t_surface - g/cp * zw(k-1)) / &
-                         t_surface )**(1.0_wp/0.286_wp)
+          rrtm_plev(0,k) = barometric_formula(zw(k-1),                         &
+                              pt_surface * exner(nzb), &
+                              surface_pressure )
        ENDDO
 
@@ -4406,7 +4380,4 @@
  SUBROUTINE radiation_tendency_ij ( i, j, tend )
 
-    USE cloud_parameters,                                                      &
-        ONLY:  pt_d_t
-
     IMPLICIT NONE
 
@@ -4421,5 +4392,5 @@
        DO k = nzb+1, nzt+1
           tend(k,j,i) = tend(k,j,i) + (rad_lw_hr(k,j,i) + rad_sw_hr(k,j,i))    &
-                                         * pt_d_t(k) * d_seconds_hour
+                                         * d_exner(k) * d_seconds_hour
        ENDDO
 #endif
@@ -4437,7 +4408,4 @@
  SUBROUTINE radiation_tendency ( tend )
 
-    USE cloud_parameters,                                                      &
-        ONLY:  pt_d_t
-
     USE indices,                                                               &
         ONLY:  nxl, nxr, nyn, nys
@@ -4457,5 +4425,5 @@
              DO k = nzb+1, nzt+1
                 tend(k,j,i) = tend(k,j,i) + ( rad_lw_hr(k,j,i)                 &
-                                          +  rad_sw_hr(k,j,i) ) * pt_d_t(k)    &
+                                          +  rad_sw_hr(k,j,i) ) * d_exner(k)   &
                                           * d_seconds_hour
              ENDDO
@@ -4525,7 +4493,7 @@
 #if ! defined( __nopointer )
      IF ( plant_canopy )  THEN
-         pchf_prep(:) = r_d * (hyp(nzub:nzut) / 100000.0_wp)**0.286_wp &
-                     / (cp * hyp(nzub:nzut) * dx*dy*dz(1)) !< equals to 1 / (rho * c_p * Vbox * T)
-         pctf_prep(:) = r_d * (hyp(nzub:nzut) / 100000.0_wp)**0.286_wp &
+         pchf_prep(:) = r_d * exner(nzub:nzut)                                 &
+                     / (c_p * hyp(nzub:nzut) * dx*dy*dz(1)) !< equals to 1 / (rho * c_p * Vbox * T)
+         pctf_prep(:) = r_d * exner(nzub:nzut)                                 &
                      / (l_v * hyp(nzub:nzut) * dx*dy*dz(1))
      ENDIF
@@ -5032,5 +5000,5 @@
 !         k                = surf_lsm_h%k(m)
 !         pt_surf_urb_l    = pt_surf_urb_l + surf_lsm_h%pt_surface(m)            &
-!                            * ( hyp(k) / 100000.0_wp )**0.286_wp
+!                            * exner(k)
 !         count_surfaces_l = count_surfaces_l + 1.0_wp
 !      ENDDO
@@ -5038,5 +5006,5 @@
 !         k                = surf_usm_h%k(m)
 !         pt_surf_urb_l    = pt_surf_urb_l + surf_usm_h%pt_surface(m)            &
-!                            * ( hyp(k) / 100000.0_wp )**0.286_wp
+!                            * exner(k)
 !         count_surfaces_l = count_surfaces_l + 1.0_wp
 !      ENDDO
@@ -5045,11 +5013,10 @@
 !            k                = surf_lsm_v(l)%k(m)
 !            pt_surf_urb_l    = pt_surf_urb_l + surf_lsm_v(l)%pt_surface(m)      &
-!                            * ( hyp(k) / 100000.0_wp )**0.286_wp
+!                            * exner(k)
 !            count_surfaces_l = count_surfaces_l + 1.0_wp
 !         ENDDO
 !         DO  m = 1, surf_usm_v(l)%ns
 !            k                = surf_usm_v(l)%k(m)
-!            pt_surf_urb_l    = pt_surf_urb_l + surf_usm_v(l)%pt_surface(m)      &
-!                            * ( hyp(k) / 100000.0_wp )**0.286_wp
+!            pt_surf_urb_l    = pt_surf_urb_l + surf_usm_v(l)%pt_surface(m) * exner(k)
 !            count_surfaces_l = count_surfaces_l + 1.0_wp
 !         ENDDO
Index: /palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3273)
+++ /palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -111,4 +114,7 @@
                   q_init, ref_state, s_init, sa_init, u_init, ug, v_init, vg
 
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bcm_rrd_global
+
        USE date_and_time_mod,                                                  &
            ONLY:  day_of_year_init, time_utc_init
@@ -125,9 +131,4 @@
        USE indices,                                                            &
            ONLY:  nz, nx, nx_on_file, ny, ny_on_file
-
-       USE microphysics_mod,                                                   &
-           ONLY:  c_sedimentation, collision_turbulence,                       &
-                  cloud_water_sedimentation, limiter_sedimentation,            &
-                  nc_const, ventilation_effect
 
        USE model_1d_mod,                                                       &
@@ -332,6 +333,4 @@
              CASE ( 'building_wall_south' )
                 READ ( 13 )  building_wall_south
-             CASE ( 'c_sedimentation' )
-                READ ( 13 )  c_sedimentation
              CASE ( 'call_psolver_at_all_substeps' )
                 READ ( 13 )  call_psolver_at_all_substeps
@@ -350,16 +349,8 @@
              CASE ( 'cloud_droplets' )
                 READ ( 13 )  cloud_droplets
-             CASE ( 'cloud_physics' )
-                READ ( 13 )  cloud_physics
-             CASE ( 'cloud_scheme' )
-                READ ( 13 )  cloud_scheme
              CASE ( 'cloud_top_radiation' )
                 READ ( 13 )  cloud_top_radiation
-             CASE ( 'cloud_water_sedimentation' )
-                READ ( 13 )  cloud_water_sedimentation
              CASE ( 'collective_wait' )
                 READ ( 13 )  collective_wait
-             CASE ( 'collision_turbulence' )
-                READ ( 13 )  collision_turbulence
              CASE ( 'conserve_volume_flow' )
                 READ ( 13 )  conserve_volume_flow
@@ -461,6 +452,4 @@
              CASE ( 'latitude' )
                 READ ( 13 )  latitude
-             CASE ( 'limiter_sedimentation' )
-                READ ( 13 )  limiter_sedimentation
              CASE ( 'longitude' )
                 READ ( 13 )  longitude
@@ -484,6 +473,4 @@
              CASE ( 'most_method' )
                 READ ( 13 )  most_method
-             CASE ( 'nc_const' )
-                READ ( 13 )  nc_const
              CASE ( 'netcdf_precision' )
                 READ ( 13 )  netcdf_precision
@@ -520,6 +507,4 @@
              CASE ( 'prandtl_number' )
                 READ ( 13 )  prandtl_number
-             CASE ( 'precipitation' )
-                READ ( 13 ) precipitation
              CASE ( 'psolver' )
                 READ ( 13 )  psolver
@@ -732,6 +717,4 @@
              CASE ( 'v_max_ijk' )
                 READ ( 13 )  v_max_ijk
-             CASE ( 'ventilation_effect' )
-                READ ( 13 )  ventilation_effect
              CASE ( 'vg' )
                 READ ( 13 )  vg
@@ -786,4 +769,6 @@
              CASE DEFAULT
 
+                IF ( .NOT. found ) CALL bcm_rrd_global( found )
+
                 IF ( .NOT. found ) CALL wtm_rrd_global( found )
 
@@ -1061,6 +1046,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, p, pt, q, ql, qc, nc, nr, prr, precipitation_amount, &
-               qr, s, sa, u, u_m_l, u_m_n, u_m_r, u_m_s, v, v_m_l, v_m_n,      &
+        ONLY:  e, kh, km, p, pt, q, ql, &
+               s, sa, u, u_m_l, u_m_n, u_m_r, u_m_s, v, v_m_l, v_m_n,      &
                v_m_r, v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
 
@@ -1073,5 +1058,5 @@
         ONLY:  cpu_log, log_point_s
 
-    USE gust_mod,                                                           &
+    USE gust_mod,                                                              &
         ONLY :  gust_rrd_local
 
@@ -1084,4 +1069,7 @@
     USE land_surface_model_mod,                                                &
         ONLY:  lsm_rrd_local
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY :  bcm_rrd_local
 
     USE particle_attributes,                                                   &
@@ -1469,31 +1457,4 @@
                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'nc' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nc_av' )
-                   IF ( .NOT. ALLOCATED( nc_av ) )  THEN
-                      ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-
-                CASE ( 'nr' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nr_av' )
-                   IF ( .NOT. ALLOCATED( nr_av ) )  THEN
-                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'p' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1525,26 +1486,4 @@
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'prr' )
-                   IF ( .NOT. ALLOCATED( prr ) )  THEN
-                      ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   prr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =            &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'prr_av' )
-                   IF ( .NOT. ALLOCATED( prr_av ) )  THEN
-                      ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   prr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'precipitation_amount' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   precipitation_amount(nysc-nbgp:nync+nbgp,                   &
-                                        nxlc-nbgp:nxrc+nbgp)  =                &
-                         tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'pt' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1573,17 +1512,4 @@
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'qc' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   qc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qc_av' )
-                   IF ( .NOT. ALLOCATED( qc_av ) )  THEN
-                      ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   qc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'ql' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1597,17 +1523,4 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
                    ql_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qr' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   qr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'qr_av' )
-                   IF ( .NOT. ALLOCATED( qr_av ) )  THEN
-                      ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   qr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -1968,4 +1881,12 @@
 
 !
+!--                Read microphysics module restart data
+                   IF ( .NOT. found ) CALL bcm_rrd_local( i, k, nxlf,          &
+                                           nxlc, nxl_on_file, nxrf, nxrc,      &
+                                           nxr_on_file, nynf, nync,            &
+                                           nyn_on_file, nysf, nysc,            &
+                                           nys_on_file, tmp_2d, tmp_3d, found )
+
+!
 !--                Read surface related variables
                    IF ( .NOT. found ) CALL surface_rrd_local( i, k, nxlf,      &
